require "motion/motion"

function love.load()
	motion.newAnimation( "frog1",
						 {"frog1.png",
						 "frog2.png",
						 "frog3.png",
						 "frog4.png"},
						0.2)
	motion.newAnimation( "frog2",
						 {"frog1.png",
						 "frog2.png",
						 "frog3.png",
						 "frog4.png"},
						 {1, 0.1, 1, 0.5})
	motion.newAnimation( "frog3",
						 {"frog1.png",
						 "frog2.png",
						 "frog3.png",
						 "frog4.png"},
						 0)
	motion.newAnimation( "frog4",
						 {"frog1.png",
						 "frog2.png",
						 "frog3.png",
						 "frog4.png"},
						 0)
end

function love.update(dt)
	motion.update()
end

function love.draw()
	love.graphics.draw(motion.get("frog1"), 100, 25)
	love.graphics.draw(motion.get("frog2"), 100, 125)
	love.graphics.draw(motion.get("frog3"), 100, 225)
	love.graphics.draw(motion.get("frog4"), 100, 325)
	
	love.graphics.setColor(255, 0, 0, 255)
	love.graphics.print("<<<---- Updating this with a fixed amount of time", 170, 55)
	love.graphics.setColor(0, 255, 0, 255)
	love.graphics.print("<<<---- Updating this with a time table: each frame has its own duration", 170, 155)
	love.graphics.setColor(0, 255, 255, 255)
	love.graphics.print("<<<---- Updating this manually. Press any key to go to the next frame", 170, 255)
	love.graphics.setColor(255, 0, 255, 255)
	love.graphics.print("<<<---- Press keys 1 to 4 to change this animation to that frame number", 170, 355)
	love.graphics.setColor(255, 255, 255, 255)
	
	love.graphics.print("Functions available in this version:\n" .. 
						"------------------------------------\n" .. 
						"· motion.newAnimation(<name:string>, <frames:table>, <interval:table/number/0>) : creates a new animation\n" .. 
						"· motion.update([name:string]) : updates animations\n" ..
						"· motion.setFrame(<name:string>, <frame:number>) : changes an animation frame to the specified frame number\n" ..
						"· motion.get(<name:string>) : returns the image corresponding to the specified animation\n" ..
						"· motion.delete(<name:string>, [frameNum:number]) : removes the specified animation\n" .. 
						"· motion.info(<name:string>) : return the number of frames and the actual frame of the specified animation\n",
						20, 450)
end

function love.keypressed(key, unicode)
	if key == "1" or key == "2" or key == "3" or key == "4" then
		motion.setFrame("frog4", tonumber(key))
	else
		motion.update("frog3")
	end
end
