-- Manager Of TImed Object aNimations

motion = {}

animations = {}

function motion.newAnimation(name, frames, interval)
	-- name = descriptive and unique name for the animation
	-- frames = table with the full path to the animation images
	-- interval = in game ticks when each frame will be changed to the next one OR
	--            table with the duration of each frame
	allCorrect = tostring(name)
	
	if name ~= "" and name ~= nil
		and type(frames) == "table" then
		
		animations[tostring(name)] = {frames = frames,
							interval = interval or 1,
							actualFrame = 1,
							timer = 0,
							markDelete = 0}
		
		if type(timeTable) == "table" and  #timeTable == #frames then
			table.remove(animations, tostring(name))
				allCorrect = ">> Invalid animation time table"
		end
	else
		allCorrect = ">> Invalid animation name"
	end
	
	return allCorrect
end

function motion.update(name)
	_dt = love.timer.getDelta()
	
	if name ~= nil then
		name = tostring(name)
		manualUpdate(name)
	else
		for i, v in pairs(animations) do
			changedFrame = false
			v.timer = v.timer + _dt
			
			if type(v.interval) == "table" then
				changedFrame = updateByTable(v)
			elseif v.interval > 0 then
				changedFrame = updateByTime(v)
			end
			
			if changedFrame then
				v.timer = 0
				v.actualFrame = v.actualFrame + 1
			
				if v.actualFrame > #v.frames then
					v.actualFrame = 1
				end
			end
			
			if v.markDelete == v.actualFrame then
				motion.delete(i)
			end
		end
	end
end

function motion.setFrame(name, frame)
	name = tostring(name)
	
	animations[name].actualFrame = frame
end

function manualUpdate(thisAnim)
	animations[thisAnim].actualFrame = animations[thisAnim].actualFrame + 1
	
	if animations[thisAnim].actualFrame > #animations[thisAnim].frames then
		animations[thisAnim].actualFrame = 1
	end
end

function updateByTime(thisAnim)
	nextFrame = false
	
	if thisAnim.timer >= thisAnim.interval then
		nextFrame = true
	end
	
	return nextFrame
end

function updateByTable(thisAnim)
	nextFrame = false
	frameTime = thisAnim.interval[thisAnim.actualFrame]
	
	if thisAnim.timer >= frameTime then
		nextFrame = true
	end
	
	return nextFrame
end

function motion.get(name)
	name = tostring(name)
	
	thisAnim = animations[name].frames
	thisFrame = animations[name].actualFrame
	
	image = thisAnim[thisFrame]
	
	return love.graphics.newImage(image)
end

function motion.delete(name, frameNum)
	name = tostring(name)
	
	if not frameNum then
		animations[name] = nil
	else
		animations[name].markDelete = frameNum
	end
end

function motion.info(name)
	name = tostring(name)
	frames, actual = false, false
	
	if animations[name] ~= nil then
		frames = #animations[name].frames
		actual = animations[name].actualFrame
	end
	
	return frames, actual
end
